#ifndef MINIXDEFS_H
#define MINIXDEFS_H

/*
 * Purpose: Definitions for routines and variables exported by osscore.c
 *
 * Do not make any modifications to these settings because OSS core modules
 * have been compiled against them. Full rebuild of OSS will be required if 
 * this file is changed.
 */
/*
 *
 * This file is part of Open Sound System.
 *
 * Copyright (C) 4Front Technologies 1996-2008.
 *
 * This this source file is released under GPL v2 license (no other versions).
 * See the COPYING file included in the main directory of this source
 * distribution for the license terms and conditions.
 *
 */



typedef unsigned int offset_t;


typedef unsigned long oss_native_word;




typedef struct _device_t {
	u16_t v_id;
	u16_t d_id;
	int devind;
	char *name;
	char *slot_name;
	u32_t base_address;
	u8_t irq;
} dev_info_t;




struct _oss_device_t
{
	int cardnum;
	int dev_type;
	int instance;
	int available;
	dev_info_t *dip;
	void *osid;
	void *devc;
	char *name;
	char *hw_info;
	int major;
	char nick[16];
	char modname[16];
	char handle[32];
	int num_audio_engines;
	int num_audioplay, num_audiorec, num_audioduplex;
	int num_mididevs;
	int num_mixerdevs;
	int num_loopdevs;
	int first_mixer;	/* This must be set to -1 by osdev_create() */

	int intrcount;
	int ackcount;
	volatile int refcount;    /* Nonzero means that the device is 
								 needed by some other (virtual) driver. */

};



#define CE_CONT		0
#define CE_NOTE		1
#define CE_WARN		2
#define CE_PANIC	3





#ifndef OSS_CONFIG_H
typedef int (*oss_tophalf_handler_t) (struct _oss_device_t * osdev);
typedef void (*oss_bottomhalf_handler_t) (struct _oss_device_t * osdev);
#endif




typedef enum uio_rw
{ UIO_READ, UIO_WRITE } uio_rw_t;


struct uio
{
	int uio_resid;
	int revive_proc_nr;
	cp_grant_id_t revive_grant;
	int revive_status;
};
typedef struct uio uio_t;

#endif
